#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct {
    int desks, monitors;
    int lab_neighbours;
} lab;

int main()
{
    int lab_count, pairs, queries;

    scanf("%d %d %d", &lab_count, &pairs, &queries);

    lab *labs = malloc(sizeof(lab) * lab_count);

    for(int i = 0; i < lab_count; i++)
    {
        scanf("%d", &labs[i].desks);
    }

    for(int i = 0; i < lab_count; i++)
    {
        scanf("%d", &labs[i].monitors);
    }

    printf("starting state: \n");

    for(int i = 0; i < lab_count; i++)
    {
        printf("%d: %d\n", i, labs[i].desks);
    }

    for(int i = 0; i < lab_count; i++)
    {
        printf("%d: %d\n", i, labs[i].monitors);
    }

    for(int i = 0; i < pairs; i++)
    {
        scanf("%*d %*d");
    }

    for(int i = 0; i < queries; i++)
    {
        char vstup[10];

        scanf(" %9s ", vstup);

        printf("nacetl %s\n", vstup);

        if(strcmp(vstup, "add") == 0)
        {
            int index, count;

            scanf("%d %s %d", &count, vstup, &index);

            if(strcmp(vstup, "desk") == 0)
            {
                labs[index - 1].desks += count;
            }
            else
            {
                labs[index - 1].monitors += count;
            }
        }
        else
        {
            int index;

            scanf("%d", &index);

            int desks = labs[index - 1].desks;
            int monitors = labs[index - 1].monitors;

            printf("desks: %d monitors: %d\n", desks, monitors);
        }
    }

    return 0;
}